Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComRdCost.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComRdCost.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComRdCost.cpp	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -38,8 +38,10 @@
 #include <math.h>
 #include <assert.h>
+#include <limits>
 #include "TComRom.h"
 #include "TComRdCost.h"
-#if H_3D
+#if NH_3D
 #include "TComDataCU.h"
+#include "TComRectangle.h"
 #endif
 
@@ -47,5 +49,5 @@
 //! \{
 
-#if H_3D_VSO
+#if NH_3D_VSO
 // SAIT_VSO_EST_A0033
 Double TComRdCost::m_dDisparityCoeff = 1.0;
@@ -58,19 +60,16 @@
 TComRdCost::~TComRdCost()
 {
-#if !FIX203
-  xUninit();
-#endif
 }
 
 // Calculate RD functions
-#if H_3D_VSO
+#if NH_3D_VSO
 Double TComRdCost::calcRdCost( UInt uiBits, Dist uiDistortion, Bool bFlag, DFunc eDFunc )
 #else
-Double TComRdCost::calcRdCost( UInt uiBits, UInt uiDistortion, Bool bFlag, DFunc eDFunc )
+Double TComRdCost::calcRdCost( UInt uiBits, Distortion uiDistortion, Bool bFlag, DFunc eDFunc )
 #endif
 {
   Double dRdCost = 0.0;
   Double dLambda = 0.0;
-  
+
   switch ( eDFunc )
   {
@@ -79,5 +78,9 @@
       break;
     case DF_SAD:
-      dLambda = (Double)m_uiLambdaMotionSAD;
+#if RExt__HIGH_BIT_DEPTH_SUPPORT
+      dLambda = m_dLambdaMotionSAD[0]; // 0 is valid, because for lossless blocks, the cost equation is modified to compensate.
+#else
+      dLambda = (Double)m_uiLambdaMotionSAD[0]; // 0 is valid, because for lossless blocks, the cost equation is modified to compensate.
+#endif
       break;
     case DF_DEFAULT:
@@ -91,13 +94,16 @@
       break;
   }
-  
-  if (bFlag)
+
+  if (bFlag) //NOTE: this "bFlag" is never true
   {
     // Intra8x8, Intra4x4 Block only...
-#if SEQUENCE_LEVEL_LOSSLESS
-    dRdCost = (Double)(uiBits);
-#else
-    dRdCost = (((Double)uiDistortion) + ((Double)uiBits * dLambda));
-#endif
+    if (m_costMode != COST_STANDARD_LOSSY)
+    {
+      dRdCost = (Double(uiDistortion) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
+    }
+    else
+    {
+      dRdCost = (((Double)uiDistortion) + ((Double)uiBits * dLambda));
+    }
   }
   else
@@ -105,22 +111,30 @@
     if (eDFunc == DF_SAD)
     {
-      dRdCost = ((Double)uiDistortion + (Double)((Int)(uiBits * dLambda+.5)>>16));
-      dRdCost = (Double)(UInt)floor(dRdCost);
+      if (m_costMode != COST_STANDARD_LOSSY)
+      {
+        dRdCost = ((Double(uiDistortion) * 65536) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
+      }
+      else
+      {
+        dRdCost = floor(Double(uiDistortion) + (floor((Double(uiBits) * dLambda) + 0.5) / 65536.0));
+      }
     }
     else
     {
-#if SEQUENCE_LEVEL_LOSSLESS
-      dRdCost = (Double)(uiBits);
-#else
-      dRdCost = ((Double)uiDistortion + (Double)((Int)(uiBits * dLambda+.5)));
-      dRdCost = (Double)(UInt)floor(dRdCost);
-#endif
-    }
-  }
-  
+      if (m_costMode != COST_STANDARD_LOSSY)
+      {
+        dRdCost = (Double(uiDistortion) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
+      }
+      else
+      {
+        dRdCost = floor(Double(uiDistortion) + (Double(uiBits) * dLambda) + 0.5);
+      }
+    }
+  }
+
   return dRdCost;
 }
 
-#if H_3D_VSO
+#if NH_3D_VSO
 Double TComRdCost::calcRdCost64( UInt64 uiBits, Dist64 uiDistortion, Bool bFlag, DFunc eDFunc )
 #else
@@ -130,5 +144,5 @@
   Double dRdCost = 0.0;
   Double dLambda = 0.0;
-  
+
   switch ( eDFunc )
   {
@@ -137,5 +151,9 @@
       break;
     case DF_SAD:
-      dLambda = (Double)m_uiLambdaMotionSAD;
+#if RExt__HIGH_BIT_DEPTH_SUPPORT
+      dLambda = m_dLambdaMotionSAD[0]; // 0 is valid, because for lossless blocks, the cost equation is modified to compensate.
+#else
+      dLambda = (Double)m_uiLambdaMotionSAD[0]; // 0 is valid, because for lossless blocks, the cost equation is modified to compensate.
+#endif
       break;
     case DF_DEFAULT:
@@ -149,13 +167,16 @@
       break;
   }
-  
-  if (bFlag)
+
+  if (bFlag) //NOTE: this "bFlag" is never true
   {
     // Intra8x8, Intra4x4 Block only...
-#if SEQUENCE_LEVEL_LOSSLESS
-    dRdCost = (Double)(uiBits);
-#else
-    dRdCost = (((Double)(Int64)uiDistortion) + ((Double)(Int64)uiBits * dLambda));
-#endif
+    if (m_costMode != COST_STANDARD_LOSSY)
+    {
+      dRdCost = (Double(uiDistortion) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
+    }
+    else
+    {
+      dRdCost = (((Double)(Int64)uiDistortion) + ((Double)(Int64)uiBits * dLambda));
+    }
   }
   else
@@ -163,27 +184,54 @@
     if (eDFunc == DF_SAD)
     {
-      dRdCost = ((Double)(Int64)uiDistortion + (Double)((Int)((Int64)uiBits * dLambda+.5)>>16));
-      dRdCost = (Double)(UInt)floor(dRdCost);
+      if (m_costMode != COST_STANDARD_LOSSY)
+      {
+        dRdCost = ((Double(uiDistortion) * 65536) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
+      }
+      else
+      {
+        dRdCost = floor(Double(uiDistortion) + (floor((Double(uiBits) * dLambda) + 0.5) / 65536.0));
+      }
     }
     else
     {
-#if SEQUENCE_LEVEL_LOSSLESS
-      dRdCost = (Double)(uiBits);
-#else
-      dRdCost = ((Double)(Int64)uiDistortion + (Double)((Int)((Int64)uiBits * dLambda+.5)));
-      dRdCost = (Double)(UInt)floor(dRdCost);
-#endif
-    }
-  }
-  
+      if (m_costMode != COST_STANDARD_LOSSY)
+      {
+        dRdCost = (Double(uiDistortion) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
+      }
+      else
+      {
+        dRdCost = floor(Double(uiDistortion) + (Double(uiBits) * dLambda) + 0.5);
+      }
+    }
+  }
+
   return dRdCost;
 }
 
-Void TComRdCost::setLambda( Double dLambda )
+Void TComRdCost::setLambda( Double dLambda, const BitDepths &bitDepths )
 {
   m_dLambda           = dLambda;
   m_sqrtLambda        = sqrt(m_dLambda);
-  m_uiLambdaMotionSAD = (UInt)floor(65536.0 * m_sqrtLambda);
-  m_uiLambdaMotionSSE = (UInt)floor(65536.0 * m_dLambda   );
+#if RExt__HIGH_BIT_DEPTH_SUPPORT
+  m_dLambdaMotionSAD[0] = 65536.0 * m_sqrtLambda;
+  m_dLambdaMotionSSE[0] = 65536.0 * m_dLambda;
+#if FULL_NBIT
+  dLambda = 0.57 * pow(2.0, ((LOSSLESS_AND_MIXED_LOSSLESS_RD_COST_TEST_QP_PRIME - 12) / 3.0));
+#else
+  dLambda = 0.57 * pow(2.0, ((LOSSLESS_AND_MIXED_LOSSLESS_RD_COST_TEST_QP_PRIME - 12 - 6 * (bitDepths.recon[CHANNEL_TYPE_LUMA] - 8)) / 3.0));
+#endif
+  m_dLambdaMotionSAD[1] = 65536.0 * sqrt(dLambda);
+  m_dLambdaMotionSSE[1] = 65536.0 * dLambda;
+#else
+  m_uiLambdaMotionSAD[0] = (UInt)floor(65536.0 * m_sqrtLambda);
+  m_uiLambdaMotionSSE[0] = (UInt)floor(65536.0 * m_dLambda   );
+#if FULL_NBIT
+  dLambda = 0.57 * pow(2.0, ((LOSSLESS_AND_MIXED_LOSSLESS_RD_COST_TEST_QP_PRIME - 12) / 3.0));
+#else
+  dLambda = 0.57 * pow(2.0, ((LOSSLESS_AND_MIXED_LOSSLESS_RD_COST_TEST_QP_PRIME - 12 - 6 * (bitDepths.recon[CHANNEL_TYPE_LUMA] - 8)) / 3.0));
+#endif
+  m_uiLambdaMotionSAD[1] = (UInt)floor(65536.0 * sqrt(dLambda));
+  m_uiLambdaMotionSSE[1] = (UInt)floor(65536.0 * dLambda   );
+#endif
 }
 
@@ -192,48 +240,47 @@
 Void TComRdCost::init()
 {
-  m_afpDistortFunc[0]  = NULL;                  // for DF_DEFAULT
-  
-  m_afpDistortFunc[1]  = TComRdCost::xGetSSE;
-  m_afpDistortFunc[2]  = TComRdCost::xGetSSE4;
-  m_afpDistortFunc[3]  = TComRdCost::xGetSSE8;
-  m_afpDistortFunc[4]  = TComRdCost::xGetSSE16;
-  m_afpDistortFunc[5]  = TComRdCost::xGetSSE32;
-  m_afpDistortFunc[6]  = TComRdCost::xGetSSE64;
-  m_afpDistortFunc[7]  = TComRdCost::xGetSSE16N;
-  
-  m_afpDistortFunc[8]  = TComRdCost::xGetSAD;
-  m_afpDistortFunc[9]  = TComRdCost::xGetSAD4;
-  m_afpDistortFunc[10] = TComRdCost::xGetSAD8;
-  m_afpDistortFunc[11] = TComRdCost::xGetSAD16;
-  m_afpDistortFunc[12] = TComRdCost::xGetSAD32;
-  m_afpDistortFunc[13] = TComRdCost::xGetSAD64;
-  m_afpDistortFunc[14] = TComRdCost::xGetSAD16N;
-  
-  m_afpDistortFunc[15] = TComRdCost::xGetSAD;
-  m_afpDistortFunc[16] = TComRdCost::xGetSAD4;
-  m_afpDistortFunc[17] = TComRdCost::xGetSAD8;
-  m_afpDistortFunc[18] = TComRdCost::xGetSAD16;
-  m_afpDistortFunc[19] = TComRdCost::xGetSAD32;
-  m_afpDistortFunc[20] = TComRdCost::xGetSAD64;
-  m_afpDistortFunc[21] = TComRdCost::xGetSAD16N;
-  
-#if AMP_SAD
-  m_afpDistortFunc[43] = TComRdCost::xGetSAD12;
-  m_afpDistortFunc[44] = TComRdCost::xGetSAD24;
-  m_afpDistortFunc[45] = TComRdCost::xGetSAD48;
-
-  m_afpDistortFunc[46] = TComRdCost::xGetSAD12;
-  m_afpDistortFunc[47] = TComRdCost::xGetSAD24;
-  m_afpDistortFunc[48] = TComRdCost::xGetSAD48;
-#endif
-  m_afpDistortFunc[22] = TComRdCost::xGetHADs;
-  m_afpDistortFunc[23] = TComRdCost::xGetHADs;
-  m_afpDistortFunc[24] = TComRdCost::xGetHADs;
-  m_afpDistortFunc[25] = TComRdCost::xGetHADs;
-  m_afpDistortFunc[26] = TComRdCost::xGetHADs;
-  m_afpDistortFunc[27] = TComRdCost::xGetHADs;
-  m_afpDistortFunc[28] = TComRdCost::xGetHADs;
-
-#if H_3D_VSO
+  m_afpDistortFunc[DF_DEFAULT] = NULL;                  // for DF_DEFAULT
+
+  m_afpDistortFunc[DF_SSE    ] = TComRdCost::xGetSSE;
+  m_afpDistortFunc[DF_SSE4   ] = TComRdCost::xGetSSE4;
+  m_afpDistortFunc[DF_SSE8   ] = TComRdCost::xGetSSE8;
+  m_afpDistortFunc[DF_SSE16  ] = TComRdCost::xGetSSE16;
+  m_afpDistortFunc[DF_SSE32  ] = TComRdCost::xGetSSE32;
+  m_afpDistortFunc[DF_SSE64  ] = TComRdCost::xGetSSE64;
+  m_afpDistortFunc[DF_SSE16N ] = TComRdCost::xGetSSE16N;
+
+  m_afpDistortFunc[DF_SAD    ] = TComRdCost::xGetSAD;
+  m_afpDistortFunc[DF_SAD4   ] = TComRdCost::xGetSAD4;
+  m_afpDistortFunc[DF_SAD8   ] = TComRdCost::xGetSAD8;
+  m_afpDistortFunc[DF_SAD16  ] = TComRdCost::xGetSAD16;
+  m_afpDistortFunc[DF_SAD32  ] = TComRdCost::xGetSAD32;
+  m_afpDistortFunc[DF_SAD64  ] = TComRdCost::xGetSAD64;
+  m_afpDistortFunc[DF_SAD16N ] = TComRdCost::xGetSAD16N;
+
+  m_afpDistortFunc[DF_SADS   ] = TComRdCost::xGetSAD;
+  m_afpDistortFunc[DF_SADS4  ] = TComRdCost::xGetSAD4;
+  m_afpDistortFunc[DF_SADS8  ] = TComRdCost::xGetSAD8;
+  m_afpDistortFunc[DF_SADS16 ] = TComRdCost::xGetSAD16;
+  m_afpDistortFunc[DF_SADS32 ] = TComRdCost::xGetSAD32;
+  m_afpDistortFunc[DF_SADS64 ] = TComRdCost::xGetSAD64;
+  m_afpDistortFunc[DF_SADS16N] = TComRdCost::xGetSAD16N;
+
+  m_afpDistortFunc[DF_SAD12  ] = TComRdCost::xGetSAD12;
+  m_afpDistortFunc[DF_SAD24  ] = TComRdCost::xGetSAD24;
+  m_afpDistortFunc[DF_SAD48  ] = TComRdCost::xGetSAD48;
+
+  m_afpDistortFunc[DF_SADS12 ] = TComRdCost::xGetSAD12;
+  m_afpDistortFunc[DF_SADS24 ] = TComRdCost::xGetSAD24;
+  m_afpDistortFunc[DF_SADS48 ] = TComRdCost::xGetSAD48;
+
+  m_afpDistortFunc[DF_HADS   ] = TComRdCost::xGetHADs;
+  m_afpDistortFunc[DF_HADS4  ] = TComRdCost::xGetHADs;
+  m_afpDistortFunc[DF_HADS8  ] = TComRdCost::xGetHADs;
+  m_afpDistortFunc[DF_HADS16 ] = TComRdCost::xGetHADs;
+  m_afpDistortFunc[DF_HADS32 ] = TComRdCost::xGetHADs;
+  m_afpDistortFunc[DF_HADS64 ] = TComRdCost::xGetHADs;
+  m_afpDistortFunc[DF_HADS16N] = TComRdCost::xGetHADs;
+
+#if NH_3D_VSO
   // SAIT_VSO_EST_A0033
   m_afpDistortFunc[29]  = TComRdCost::xGetVSD;
@@ -245,16 +292,15 @@
   m_afpDistortFunc[35]  = TComRdCost::xGetVSD16N;
 #endif
-#if !FIX203
-  m_puiComponentCostOriginP = NULL;
-  m_puiComponentCost        = NULL;
-  m_puiVerCost              = NULL;
-  m_puiHorCost              = NULL;
-#endif
-  m_uiCost                  = 0;
-  m_iCostScale              = 0;
-#if !FIX203
-  m_iSearchLimit            = 0xdeaddead;
-#endif
-#if H_3D_VSO
+
+  m_costMode                   = COST_STANDARD_LOSSY;
+
+#if RExt__HIGH_BIT_DEPTH_SUPPORT
+  m_dCost                      = 0;
+#else
+  m_uiCost                     = 0;
+#endif
+  m_iCostScale                 = 0;
+
+#if NH_3D_VSO
   m_bUseVSO                 = false;
   m_uiVSOMode               = 0; 
@@ -268,48 +314,14 @@
   m_bUseMask                = false;
 #endif
-}
-
-#if !FIX203
-Void TComRdCost::initRateDistortionModel( Int iSubPelSearchLimit )
-{
-  // make it larger
-  iSubPelSearchLimit += 4;
-  iSubPelSearchLimit *= 8;
-  
-  if( m_iSearchLimit != iSubPelSearchLimit )
-  {
-    xUninit();
-    
-    m_iSearchLimit = iSubPelSearchLimit;
-    
-    m_puiComponentCostOriginP = new UInt[ 4 * iSubPelSearchLimit ];
-    iSubPelSearchLimit *= 2;
-    
-    m_puiComponentCost = m_puiComponentCostOriginP + iSubPelSearchLimit;
-    
-    for( Int n = -iSubPelSearchLimit; n < iSubPelSearchLimit; n++)
-    {
-      m_puiComponentCost[n] = xGetComponentBits( n );
-    }
-  }
-}
-
-Void TComRdCost::xUninit()
-{
-  if( NULL != m_puiComponentCostOriginP )
-  {
-    delete [] m_puiComponentCostOriginP;
-    m_puiComponentCostOriginP = NULL;
-  }
-}
-#endif
-
-UInt TComRdCost::xGetComponentBits( Int iVal )
-{
+
+}
+
+// Static member function
+UInt TComRdCost::xGetExpGolombNumberOfBits( Int iVal )
+{
+  assert(iVal != std::numeric_limits<Int>::min());
   UInt uiLength = 1;
-  UInt uiTemp   = ( iVal <= 0) ? (-iVal<<1)+1: (iVal<<1);
-  
-  assert ( uiTemp );
-  
+  UInt uiTemp   = ( iVal <= 0) ? (UInt(-iVal)<<1)+1: UInt(iVal<<1);
+
   while ( 1 != uiTemp )
   {
@@ -317,5 +329,5 @@
     uiLength += 2;
   }
-  
+
   return uiLength;
 }
@@ -327,5 +339,5 @@
   rcDistParam.iRows    = uiBlkHeight;
   rcDistParam.DistFunc = m_afpDistortFunc[eDFunc + g_aucConvertToBit[ rcDistParam.iCols ] + 1 ];
-  
+
 #if H_3D_DBBP
   if( m_bUseMask )
@@ -363,28 +375,26 @@
   rcDistParam.pOrg = pcPatternKey->getROIY();
   rcDistParam.pCur = piRefY;
-  
+
   rcDistParam.iStrideOrg = pcPatternKey->getPatternLStride();
   rcDistParam.iStrideCur = iRefStride;
-  
+
   // set Block Width / Height
   rcDistParam.iCols    = pcPatternKey->getROIYWidth();
   rcDistParam.iRows    = pcPatternKey->getROIYHeight();
   rcDistParam.DistFunc = m_afpDistortFunc[DF_SAD + g_aucConvertToBit[ rcDistParam.iCols ] + 1 ];
-  
-#if AMP_SAD
+
   if (rcDistParam.iCols == 12)
   {
-    rcDistParam.DistFunc = m_afpDistortFunc[43 ];
+    rcDistParam.DistFunc = m_afpDistortFunc[DF_SAD12];
   }
   else if (rcDistParam.iCols == 24)
   {
-    rcDistParam.DistFunc = m_afpDistortFunc[44 ];
+    rcDistParam.DistFunc = m_afpDistortFunc[DF_SAD24];
   }
   else if (rcDistParam.iCols == 48)
   {
-    rcDistParam.DistFunc = m_afpDistortFunc[45 ];
-  }
-#endif
-  
+    rcDistParam.DistFunc = m_afpDistortFunc[DF_SAD48];
+  }
+
 #if H_3D_DBBP
   if( m_bUseMask )
@@ -403,33 +413,31 @@
   rcDistParam.pOrg = pcPatternKey->getROIY();
   rcDistParam.pCur = piRefY;
-  
+
   rcDistParam.iStrideOrg = pcPatternKey->getPatternLStride();
   rcDistParam.iStrideCur = iRefStride * iStep;
-  
+
   // set Step for interpolated buffer
   rcDistParam.iStep = iStep;
-  
+
   // set Block Width / Height
   rcDistParam.iCols    = pcPatternKey->getROIYWidth();
   rcDistParam.iRows    = pcPatternKey->getROIYHeight();
-  
+
   // set distortion function
   if ( !bHADME )
   {
     rcDistParam.DistFunc = m_afpDistortFunc[DF_SADS + g_aucConvertToBit[ rcDistParam.iCols ] + 1 ];
-#if AMP_SAD
     if (rcDistParam.iCols == 12)
     {
-      rcDistParam.DistFunc = m_afpDistortFunc[46 ];
+      rcDistParam.DistFunc = m_afpDistortFunc[DF_SADS12];
     }
     else if (rcDistParam.iCols == 24)
     {
-      rcDistParam.DistFunc = m_afpDistortFunc[47 ];
+      rcDistParam.DistFunc = m_afpDistortFunc[DF_SADS24];
     }
     else if (rcDistParam.iCols == 48)
     {
-      rcDistParam.DistFunc = m_afpDistortFunc[48 ];
-    }
-#endif
+      rcDistParam.DistFunc = m_afpDistortFunc[DF_SADS48];
+    }
   }
   else
@@ -437,5 +445,5 @@
     rcDistParam.DistFunc = m_afpDistortFunc[DF_HADS + g_aucConvertToBit[ rcDistParam.iCols ] + 1 ];
   }
-  
+
 #if H_3D_DBBP
   if( m_bUseMask )
@@ -448,6 +456,5 @@
 }
 
-Void
-TComRdCost::setDistParam( DistParam& rcDP, Int bitDepth, Pel* p1, Int iStride1, Pel* p2, Int iStride2, Int iWidth, Int iHeight, Bool bHadamard )
+Void TComRdCost::setDistParam( DistParam& rcDP, Int bitDepth, Pel* p1, Int iStride1, Pel* p2, Int iStride2, Int iWidth, Int iHeight, Bool bHadamard )
 {
   rcDP.pOrg       = p1;
@@ -469,9 +476,9 @@
 }
 
-UInt TComRdCost::calcHAD(Int bitDepth, Pel* pi0, Int iStride0, Pel* pi1, Int iStride1, Int iWidth, Int iHeight )
-{
-  UInt uiSum = 0;
+Distortion TComRdCost::calcHAD( Int bitDepth, Pel* pi0, Int iStride0, Pel* pi1, Int iStride1, Int iWidth, Int iHeight )
+{
+  Distortion uiSum = 0;
   Int x, y;
-  
+
   if ( ( (iWidth % 8) == 0 ) && ( (iHeight % 8) == 0 ) )
   {
@@ -488,6 +495,6 @@
   else
   {
-    assert(iWidth % 4 == 0 && iHeight % 4 == 0);
-    
+    assert ( ( (iWidth % 4) == 0 ) && ( (iHeight % 4) == 0 ) );
+
     for ( y=0; y<iHeight; y+= 4 )
     {
@@ -500,7 +507,6 @@
     }
   }
-  
-  return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(bitDepth-8);
-
+
+  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(bitDepth-8) );
 }
 
@@ -542,5 +548,5 @@
 
 
-UInt TComRdCost::getDistPart(Int bitDepth, Pel* piCur, Int iCurStride,  Pel* piOrg, Int iOrgStride, UInt uiBlkWidth, UInt uiBlkHeight, TextType eText, DFunc eDFunc)
+Distortion TComRdCost::getDistPart( Int bitDepth, Pel* piCur, Int iCurStride,  Pel* piOrg, Int iOrgStride, UInt uiBlkWidth, UInt uiBlkHeight, const ComponentID compID, DFunc eDFunc )
 {
   DistParam cDtParam;
@@ -553,6 +559,6 @@
 
   cDtParam.bApplyWeight = false;
-  cDtParam.uiComp       = 255;    // just for assert: to be sure it was set before use, since only values 0,1 or 2 are allowed.
-  cDtParam.bitDepth = bitDepth;
+  cDtParam.compIdx      = MAX_NUM_COMPONENT; // just for assert: to be sure it was set before use
+  cDtParam.bitDepth     = bitDepth;
 
 #if H_3D_IC
@@ -562,11 +568,8 @@
   cDtParam.bUseSDCMRSAD = false;
 #endif
-  if (eText == TEXT_CHROMA_U)
-  {
-   return ((Int) (m_cbDistortionWeight * cDtParam.DistFunc( &cDtParam )));
-  }
-  else if (eText == TEXT_CHROMA_V)
-  {
-   return ((Int) (m_crDistortionWeight * cDtParam.DistFunc( &cDtParam )));
+
+  if (isChroma(compID))
+  {
+    return ((Distortion) (m_distortionWeight[compID] * cDtParam.DistFunc( &cDtParam )));
   }
   else
@@ -575,13 +578,13 @@
   }
 }
-#if H_3D_VSO
+#if NH_3D_VSO
 // SAIT_VSO_EST_A0033
-UInt TComRdCost::getDistPartVSD( TComDataCU* pcCU, UInt uiPartOffset, Pel* piCur, Int iCurStride,  Pel* piOrg, Int iOrgStride, UInt uiBlkWidth, UInt uiBlkHeight,  Bool bHAD, DFunc eDFunc )
+UInt TComRdCost::getDistPartVSD( TComDataCU* pcCU, UInt uiPartOffset, Int bitDepth, Pel* piCur, Int iCurStride,  Pel* piOrg, Int iOrgStride, UInt uiBlkWidth, UInt uiBlkHeight,  Bool bHAD, DFunc eDFunc )
 {
   AOT( ( m_dDisparityCoeff <= 0 ) || ( m_dDisparityCoeff > 10 ) );
 
-  Pel* piVirRec  = m_pcVideoRecPicYuv->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()+uiPartOffset); 
-  Pel* piVirOrg  = m_pcDepthPicYuv   ->getLumaAddr(pcCU->getAddr(),pcCU->getZorderIdxInCU()+uiPartOffset); 
-  Int iVirStride = m_pcVideoRecPicYuv->getStride();   
+  Pel* piVirRec  = m_pcVideoRecPicYuv->getAddr( COMPONENT_Y, pcCU->getCtuRsAddr( ), pcCU->getZorderIdxInCtu()+uiPartOffset ); 
+  Pel* piVirOrg  = m_pcDepthPicYuv   ->getAddr( COMPONENT_Y, pcCU->getCtuRsAddr( ), pcCU->getZorderIdxInCtu()+uiPartOffset ); 
+  Int iVirStride = m_pcVideoRecPicYuv->getStride( COMPONENT_Y );   
 
   DistParam cDtParam;
@@ -596,8 +599,7 @@
   cDtParam.iStep      = 1;
 
-  cDtParam.bApplyWeight = false;
-  cDtParam.uiComp       = 255;    // just for assert: to be sure it was set before use, since only values 0,1 or 2 are allowed.
-
-  cDtParam.bitDepth   = g_bitDepthY;
+  cDtParam.bApplyWeight = false;  
+
+  cDtParam.bitDepth   = bitDepth;
 
   Dist dist = cDtParam.DistFunc( &cDtParam );
@@ -611,9 +613,9 @@
     if ( !bHAD )
     {
-      distDepth = (Dist) getDistPart( g_bitDepthY, piCur, iCurStride, piOrg, iOrgStride, uiBlkWidth, uiBlkHeight);
+      distDepth = (Dist) getDistPart( bitDepth, piCur, iCurStride, piOrg, iOrgStride, uiBlkWidth, uiBlkHeight, COMPONENT_Y);
     }
     else
     {
-      distDepth = (Dist) calcHAD( g_bitDepthY, piCur, iCurStride, piOrg, iOrgStride, uiBlkWidth, uiBlkHeight);
+      distDepth = (Dist) calcHAD( bitDepth, piCur, iCurStride, piOrg, iOrgStride, uiBlkWidth, uiBlkHeight);
     }
 
@@ -756,9 +758,9 @@
 // --------------------------------------------------------------------------------------------------------------------
 
-UInt TComRdCost::xGetSAD( DistParam* pcDtParam )
+Distortion TComRdCost::xGetSAD( DistParam* pcDtParam )
 {
   if ( pcDtParam->bApplyWeight )
   {
-    return xGetSADw( pcDtParam );
+    return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
 #if H_3D_IC
@@ -774,13 +776,14 @@
   }
 #endif
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iCols   = pcDtParam->iCols;
   Int  iStrideCur = pcDtParam->iStrideCur;
   Int  iStrideOrg = pcDtParam->iStrideOrg;
-  
-  UInt uiSum = 0;
-  
+
+  Distortion uiSum = 0;
+
   for( ; iRows != 0; iRows-- )
   {
@@ -792,14 +795,15 @@
     piCur += iStrideCur;
   }
-  
-  return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8);
-}
-
-UInt TComRdCost::xGetSAD4( DistParam* pcDtParam )
-{
-  if ( pcDtParam->bApplyWeight ) 
-  {
-    return xGetSADw( pcDtParam );
-  }
+
+  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
+}
+
+Distortion TComRdCost::xGetSAD4( DistParam* pcDtParam )
+{
+  if ( pcDtParam->bApplyWeight )
+  {
+    return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
+  }
+
 #if H_3D_IC
   if( pcDtParam->bUseIC )
@@ -814,6 +818,7 @@
   }
 #endif
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -821,7 +826,7 @@
   Int  iStrideCur = pcDtParam->iStrideCur*iSubStep;
   Int  iStrideOrg = pcDtParam->iStrideOrg*iSubStep;
-  
-  UInt uiSum = 0;
-  
+
+  Distortion uiSum = 0;
+
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -830,19 +835,20 @@
     uiSum += abs( piOrg[2] - piCur[2] );
     uiSum += abs( piOrg[3] - piCur[3] );
-    
-    piOrg += iStrideOrg;
-    piCur += iStrideCur;
-  }
-  
+
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
   uiSum <<= iSubShift;
-  return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8);
-}
-
-UInt TComRdCost::xGetSAD8( DistParam* pcDtParam )
+  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
+}
+
+Distortion TComRdCost::xGetSAD8( DistParam* pcDtParam )
 {
   if ( pcDtParam->bApplyWeight )
   {
-    return xGetSADw( pcDtParam );
-  }
+    return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
+  }
+
 #if H_3D_IC
   if( pcDtParam->bUseIC )
@@ -857,6 +863,7 @@
   }
 #endif
-  Pel* piOrg      = pcDtParam->pOrg;
-  Pel* piCur      = pcDtParam->pCur;
+
+  const Pel* piOrg      = pcDtParam->pOrg;
+  const Pel* piCur      = pcDtParam->pCur;
   Int  iRows      = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -864,7 +871,7 @@
   Int  iStrideCur = pcDtParam->iStrideCur*iSubStep;
   Int  iStrideOrg = pcDtParam->iStrideOrg*iSubStep;
-  
-  UInt uiSum = 0;
-  
+
+  Distortion uiSum = 0;
+
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -877,19 +884,20 @@
     uiSum += abs( piOrg[6] - piCur[6] );
     uiSum += abs( piOrg[7] - piCur[7] );
-    
-    piOrg += iStrideOrg;
-    piCur += iStrideCur;
-  }
-  
+
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
   uiSum <<= iSubShift;
-  return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8);
-}
-
-UInt TComRdCost::xGetSAD16( DistParam* pcDtParam )
+  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
+}
+
+Distortion TComRdCost::xGetSAD16( DistParam* pcDtParam )
 {
   if ( pcDtParam->bApplyWeight )
   {
-    return xGetSADw( pcDtParam );
-  }
+    return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
+  }
+
 #if H_3D_IC
   if( pcDtParam->bUseIC )
@@ -904,6 +912,7 @@
   }
 #endif
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -911,7 +920,7 @@
   Int  iStrideCur = pcDtParam->iStrideCur*iSubStep;
   Int  iStrideOrg = pcDtParam->iStrideOrg*iSubStep;
-  
-  UInt uiSum = 0;
-  
+
+  Distortion uiSum = 0;
+
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -932,19 +941,18 @@
     uiSum += abs( piOrg[14] - piCur[14] );
     uiSum += abs( piOrg[15] - piCur[15] );
-    
-    piOrg += iStrideOrg;
-    piCur += iStrideCur;
-  }
-  
+
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
   uiSum <<= iSubShift;
-  return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8);
-}
-
-#if AMP_SAD
-UInt TComRdCost::xGetSAD12( DistParam* pcDtParam )
+  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
+}
+
+Distortion TComRdCost::xGetSAD12( DistParam* pcDtParam )
 {
   if ( pcDtParam->bApplyWeight )
   {
-    return xGetSADw( pcDtParam );
+    return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
 #if H_3D_IC
@@ -960,6 +968,7 @@
   }
 #endif
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -967,7 +976,7 @@
   Int  iStrideCur = pcDtParam->iStrideCur*iSubStep;
   Int  iStrideOrg = pcDtParam->iStrideOrg*iSubStep;
-  
-  UInt uiSum = 0;
-  
+
+  Distortion uiSum = 0;
+
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -984,15 +993,14 @@
     uiSum += abs( piOrg[10] - piCur[10] );
     uiSum += abs( piOrg[11] - piCur[11] );
-    
-    piOrg += iStrideOrg;
-    piCur += iStrideCur;
-  }
-  
+
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
   uiSum <<= iSubShift;
-  return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8);
-}
-#endif
-
-UInt TComRdCost::xGetSAD16N( DistParam* pcDtParam )
+  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
+}
+
+Distortion TComRdCost::xGetSAD16N( DistParam* pcDtParam )
 {
 #if H_3D_IC
@@ -1008,6 +1016,7 @@
   }
 #endif
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iCols   = pcDtParam->iCols;
@@ -1016,7 +1025,7 @@
   Int  iStrideCur = pcDtParam->iStrideCur*iSubStep;
   Int  iStrideOrg = pcDtParam->iStrideOrg*iSubStep;
-  
-  UInt uiSum = 0;
-  
+
+  Distortion uiSum = 0;
+
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -1043,15 +1052,16 @@
     piCur += iStrideCur;
   }
-  
+
   uiSum <<= iSubShift;
-  return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8);
-}
-
-UInt TComRdCost::xGetSAD32( DistParam* pcDtParam )
+  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
+}
+
+Distortion TComRdCost::xGetSAD32( DistParam* pcDtParam )
 {
   if ( pcDtParam->bApplyWeight )
   {
-    return xGetSADw( pcDtParam );
-  }
+    return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
+  }
+
 #if H_3D_IC
   if( pcDtParam->bUseIC )
@@ -1066,6 +1076,7 @@
   }
 #endif
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -1073,7 +1084,7 @@
   Int  iStrideCur = pcDtParam->iStrideCur*iSubStep;
   Int  iStrideOrg = pcDtParam->iStrideOrg*iSubStep;
-  
-  UInt uiSum = 0;
-  
+
+  Distortion uiSum = 0;
+
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -1110,20 +1121,20 @@
     uiSum += abs( piOrg[30] - piCur[30] );
     uiSum += abs( piOrg[31] - piCur[31] );
-    
-    piOrg += iStrideOrg;
-    piCur += iStrideCur;
-  }
-  
+
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
   uiSum <<= iSubShift;
-  return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8);
-}
-
-#if AMP_SAD
-UInt TComRdCost::xGetSAD24( DistParam* pcDtParam )
+  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
+}
+
+Distortion TComRdCost::xGetSAD24( DistParam* pcDtParam )
 {
   if ( pcDtParam->bApplyWeight )
   {
-    return xGetSADw( pcDtParam );
-  }
+    return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
+  }
+
 #if H_3D_IC
   if( pcDtParam->bUseIC )
@@ -1138,6 +1149,7 @@
   }
 #endif
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -1145,7 +1157,7 @@
   Int  iStrideCur = pcDtParam->iStrideCur*iSubStep;
   Int  iStrideOrg = pcDtParam->iStrideOrg*iSubStep;
-  
-  UInt uiSum = 0;
-  
+
+  Distortion uiSum = 0;
+
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -1174,21 +1186,20 @@
     uiSum += abs( piOrg[22] - piCur[22] );
     uiSum += abs( piOrg[23] - piCur[23] );
-    
-    piOrg += iStrideOrg;
-    piCur += iStrideCur;
-  }
-  
+
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
   uiSum <<= iSubShift;
-  return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8);
-}
-
-#endif
-
-UInt TComRdCost::xGetSAD64( DistParam* pcDtParam )
+  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
+}
+
+Distortion TComRdCost::xGetSAD64( DistParam* pcDtParam )
 {
   if ( pcDtParam->bApplyWeight )
   {
-    return xGetSADw( pcDtParam );
-  }
+    return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
+  }
+
 #if H_3D_IC
   if( pcDtParam->bUseIC )
@@ -1203,6 +1214,7 @@
   }
 #endif
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -1210,7 +1222,7 @@
   Int  iStrideCur = pcDtParam->iStrideCur*iSubStep;
   Int  iStrideOrg = pcDtParam->iStrideOrg*iSubStep;
-  
-  UInt uiSum = 0;
-  
+
+  Distortion uiSum = 0;
+
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -1279,19 +1291,18 @@
     uiSum += abs( piOrg[62] - piCur[62] );
     uiSum += abs( piOrg[63] - piCur[63] );
-    
-    piOrg += iStrideOrg;
-    piCur += iStrideCur;
-  }
-  
+
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
   uiSum <<= iSubShift;
-  return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8);
-}
-
-#if AMP_SAD
-UInt TComRdCost::xGetSAD48( DistParam* pcDtParam )
+  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
+}
+
+Distortion TComRdCost::xGetSAD48( DistParam* pcDtParam )
 {
   if ( pcDtParam->bApplyWeight )
   {
-    return xGetSADw( pcDtParam );
+    return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
 #if H_3D_IC
@@ -1307,6 +1318,7 @@
   }
 #endif
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -1314,7 +1326,7 @@
   Int  iStrideCur = pcDtParam->iStrideCur*iSubStep;
   Int  iStrideOrg = pcDtParam->iStrideOrg*iSubStep;
-  
-  UInt uiSum = 0;
-  
+
+  Distortion uiSum = 0;
+
   for( ; iRows != 0; iRows-=iSubStep )
   {
